Bug 316171 - in FTP prozilla fails with assertion
in FTP prozilla fails with assertion
Status: CLOSED WONTFIX
Product: Fedora
Classification: Fedora
Component: prozilla (Show other bugs)
7
All Linux
low Severity medium
: ---
: ---
Assigned To: kushaldas@gmail.com
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2007-10-02 17:04 EDT by Hasan Ceylan
Modified: 2008-06-16 22:34 EDT (History)
1 user (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2008-06-16 22:34:06 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Hasan Ceylan 2007-10-02 17:04:52 EDT
Description of problem:
During ftp file-list prozilla reads from socket only once. If not all the
expected has been available, it fails with assertion error.

Version-Release number of selected component (if applicable):
2.0.4 but should be all

How reproducible:
everytime

Steps to Reproduce:
1. do 
#proz --no-curses
ftp://ftp.linux.org.tr/pub/fedora/linux/releases/test/7.91/Fedora/i386/iso/Fedora-7.91-i386-DVD.iso
2. see the assertion error
3.
  
Actual results:
throws assertion error

Expected results:
should not

Additional info:
prozilla should read from sock until either:
- an error occurs
- time out occurs
- data ending with '\r\n\0' is available

Here's the patch to correct the behaviour:
--- ftp.c       2006-02-08 19:19:53.000000000 +0200
+++ ftp.c.new   2007-10-02 23:49:32.000000000 +0300
@@ -1065,16 +1065,23 @@
 
   /* Now read the data to the buffer. */
   /* TODO Create a buffer which dynamically resizes itself as we add data. */
-
-  if (krecv(connection->data_sock, buffer, sizeof(buffer), 0,
-           &connection->xfer_timeout) == -1)
-  {
-    connection_show_message(connection,
-                           _("Error receiving FTP transfer data: %s"),
-                           strerror(errno));
-    return FTPERR;
-  }
-
+  char* ptr = buffer;
+  do {
+         int read;
+         if (read = krecv(connection->data_sock, ptr, sizeof(buffer) - (ptr -
buffer), 0,
+                   &connection->xfer_timeout) == -1)
+         {
+           connection_show_message(connection,
+                                   _("Error receiving FTP transfer data: %s"),
+                                   strerror(errno));
+           return FTPERR;
+         }
+
+         ptr += read;
+         if (strstr(buffer, "\r\n\0"))
+                 break;
+  } while (1);
+  
   proz_debug(_("String received after the LIST command = %s"), buffer);
 
   while ((tmp = strrchr(buffer, '\n')) || (tmp = strrchr(buffer, '\r')))



Regards,
Hasan Ceylan
Comment 1 Bug Zapper 2008-05-14 10:36:20 EDT
This message is a reminder that Fedora 7 is nearing the end of life. Approximately 30 (thirty) days from now Fedora will stop maintaining and issuing updates for Fedora 7. It is Fedora's policy to close all bug reports from releases that are no longer maintained. At that time this bug will be closed as WONTFIX if it remains open with a Fedora 'version' of '7'.

Package Maintainer: If you wish for this bug to remain open because you plan to fix it in a currently maintained version, simply change the 'version' to a later Fedora version prior to Fedora 7's end of life.

Bug Reporter: Thank you for reporting this issue and we are sorry that we may not be able to fix it before Fedora 7 is end of life. If you would still like to see this bug fixed and are able to reproduce it against a later version of Fedora please change the 'version' of this bug. If you are unable to change the version, please add a comment here and someone will do it for you.

Although we aim to fix as many bugs as possible during every release's lifetime, sometimes those efforts are overtaken by events. Often a more recent Fedora release includes newer upstream software that fixes bugs or makes them obsolete. If possible, it is recommended that you try the newest available Fedora distribution to see if your bug still exists.

Please read the Release Notes for the newest Fedora distribution to make sure it will meet your needs:
http://docs.fedoraproject.org/release-notes/

The process we are following is described here: http://fedoraproject.org/wiki/BugZappers/HouseKeeping
Comment 2 Bug Zapper 2008-06-16 22:34:04 EDT
Fedora 7 changed to end-of-life (EOL) status on June 13, 2008. 
Fedora 7 is no longer maintained, which means that it will not 
receive any further security or bug fix updates. As a result we 
are closing this bug. 

If you can reproduce this bug against a currently maintained version 
of Fedora please feel free to reopen this bug against that version.

Thank you for reporting this bug and we are sorry it could not be fixed.

Note You need to log in before you can comment on or make changes to this bug.